class com.itpremium.utils.WaveEngine
{
   var type;
   var stack;
   var debugOn;
   var mute;
   var _mc;
   var __autoDelete;
   var __num;
   var __parent;
   var _numSound = 0;
   var _volume = 100;
   static var _numClass = 0;
   function WaveEngine(type, debugOn)
   {
      this.type = type != undefined ? type : 1;
      this.stack = new Object();
      this.debugOn = type != undefined ? debugOn : false;
      this.mute = false;
      this.init();
   }
   function init()
   {
      com.itpremium.utils.WaveEngine._numClass = com.itpremium.utils.WaveEngine._numClass + 1;
      this._mc = _root.createEmptyMovieClip("WaveEngine_" + com.itpremium.utils.WaveEngine._numClass + "_" + this.type,_root.getNextHighestDepth());
   }
   function soundOff()
   {
      if(!this.mute)
      {
         this.debug("soundOff()");
         for(var _loc2_ in this.stack)
         {
            this.stack[_loc2_]._oldVolume = this.stack[_loc2_].getVolume();
            this.setVolume(_loc2_,0);
         }
         this.mute = true;
      }
   }
   function soundOn()
   {
      if(this.mute)
      {
         this.mute = false;
         this.debug("soundOn()");
         for(var _loc3_ in this.stack)
         {
            var _loc2_ = this.stack[_loc3_]._oldVolume != undefined ? this.stack[_loc3_]._oldVolume : 100;
            this.setVolume(_loc3_,_loc2_);
         }
      }
   }
   function getSoundStatus()
   {
      return !this.mute;
   }
   function play(id, secondsOffset, loops, autoDelete)
   {
      if(id == undefined || this.stack[id] == undefined)
      {
         return 0;
      }
      if(this.type == 2)
      {
         this.stopAll();
      }
      secondsOffset = secondsOffset != undefined ? secondsOffset : 0;
      loops = loops != undefined ? loops : 1;
      autoDelete = autoDelete != undefined ? autoDelete : true;
      var _loc3_ = this.stack[id];
      if(this.mute)
      {
         _loc3_.setVolume(0);
      }
      else
      {
         _loc3_.setVolume(this._volume);
      }
      if(this.type == 2)
      {
         loops = 65536;
      }
      _loc3_.start(secondsOffset,loops);
      this.debug("play(" + _loc3_.__link + ", " + secondsOffset + ", " + loops + ")");
   }
   function playAll(secondsOffset, loops, autoDelete)
   {
      for(var _loc5_ in this.stack)
      {
         this.play(_loc5_,secondsOffset,loops,autoDelete);
      }
   }
   function addStream(link_name, autoDelete)
   {
      if(link_name == undefined)
      {
         return 0;
      }
      autoDelete = autoDelete != undefined ? autoDelete : true;
      var _loc4_ = this._mc.createEmptyMovieClip("attachS_" + ++this._numSound,this._mc.getNextHighestDepth());
      var _loc2_ = new Sound(_loc4_);
      _loc2_.attachSound(link_name);
      _loc2_.__parent = this;
      _loc2_.__link = link_name;
      _loc2_.__num = this._numSound;
      _loc2_.__mc = _loc4_;
      _loc2_.__autoDelete = autoDelete;
      _loc2_.onSoundComplete = function()
      {
         if(this.__autoDelete)
         {
            this.__parent.deleteSound(this.__num);
         }
      };
      this.debug("addStream(" + link_name + ")");
      this.stack[this._numSound] = _loc2_;
      return _loc2_.__num;
   }
   function deleteSound(id)
   {
      if(id == undefined || this.stack[id] == undefined)
      {
         return 0;
      }
      var _loc2_ = this.stack[id];
      this.debug("Stack deletes a " + _loc2_.__link);
      delete this.stack[id];
      removeMovieClip(_loc2_.__mc);
   }
   function deleteAllSound()
   {
      this.debug("deleteAllSound()");
      for(var _loc2_ in this.stack)
      {
         this.deleteSound(_loc2_);
      }
   }
   function stop(id)
   {
      if(id == undefined || this.stack[id] == undefined)
      {
         return 0;
      }
      var _loc3_ = this.stack[id];
      _loc3_.stop();
      this.debug("stop(" + _loc3_.__link + ")");
      if(_loc3_.__autoDelete)
      {
         if(id != this._numSound || this.type != 2)
         {
            this.deleteSound(id);
         }
      }
   }
   function stopAll()
   {
      this.debug("stopAll()");
      for(var _loc2_ in this.stack)
      {
         this.stop(_loc2_);
      }
   }
   function setVolume(id, volume)
   {
      if(id == undefined || volume == undefined || this.stack[id] == undefined)
      {
         return 0;
      }
      var _loc2_ = this.stack[id];
      if(this.mute)
      {
         _loc2_._oldVolume = volume;
         return 0;
      }
      this.debug("setVolume(" + _loc2_.__link + ", " + volume + ")");
      if(_loc2_ != undefined)
      {
         _loc2_.setVolume(volume);
      }
   }
   function setAllVolume(volume)
   {
      for(var _loc3_ in this.stack)
      {
         this.setVolume(_loc3_,volume);
      }
      this._volume = volume;
   }
   function debug(msg)
   {
      if(this.debugOn)
      {
         trace(this.type + " " + msg);
      }
   }
   function toString()
   {
      return "[class WaveEngine::" + (this.type != 1 ? "Music" : "Sound") + "]";
   }
}
